unit sybimage;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,dsgnintf,sybtable,extctrls;

type SybObjectname = string[30];

type
  TTypes = (datetime,float,int,char,bit,text);

type
  Tsybobjectproperty = class(TStringProperty)
  public
    procedure GetValues(TheProc: TGetStrProc); override;
    function getattributes:Tpropertyattributes; override;
  end;

type
  TSybImage = class(TImage)
  private
    fdatatype     :SybObjectname;
    ftablename    :SybObjectname;
    ftable        :tsybtable;
    fdatafield    :SybObjectname;
    fisprimarykey :boolean;
    procedure Setdatatype(Value :SybObjectname);
    procedure Settablename(Value :SybObjectname);
    procedure Setdatafield(Value :SybObjectname);
    function getvalue:string;
    procedure setvalue(value:string);
    procedure Setisprimarykey(Value :boolean);
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor destroy; override;
    procedure setname(const NewName:Tcomponentname); override;
    property Datatype:SybObjectname read fdatatype write setdatatype; {fdatatype;}
  published
    property TableName :SybObjectname read FTableName write settablename;
    property DataField :SybObjectname read fdatafield write setdatafield;
    property Value:string read getvalue write setvalue;
    property IsPrimaryKey:boolean read fisprimarykey write setIsPrimaryKey stored false;
  end;

procedure Register;

var from_create :boolean;

implementation
uses sybase_components;

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(SybObjectname),tsybimage,'',Tsybobjectproperty);
  RegisterComponents('Sybase DBLIB', [tsybimage]);
end;

constructor tsybimage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  setdatatype('text');
  from_create:=true;
  fIsPrimaryKey:=false;
  height:=90;
  if fieldslist = nil then
  begin
    FieldsList:=TList.create;
  end;
end;

destructor tsybimage.destroy;
var thisform  :tform;
    i,j       :smallint;
    asybtable :tsybtable;
begin
  thisform:=tform(owner);
  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(name);
      break;
    end;
  end;
  fieldslist.remove(self);
  inherited destroy;
end;

procedure tsybimage.Setisprimarykey(Value :boolean);
begin
  fisprimarykey:=value;
end;

function tsybimage.getvalue:string;
begin
  result:=text;
end;

procedure tsybimage.setvalue(value:string);
begin
  text:=value;
end;

procedure tsybimage.setname(const NewName:Tcomponentname);
var oldname :Tcomponentname;
    thisform  :tform;
    i         :smallint;
    asybtable :tsybtable;
begin
  oldname:=name;
  thisform:=tform(owner);
  inherited setname(NewName);
  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(oldname);
      asybtable.addfield(name);
      break;
    end;
  end;

  if fieldslist.indexof(self) = -1 then
    fieldslist.add(self)
  else
  begin
    fieldslist.items[fieldslist.indexof(self)]:=self;
  end;

end;

procedure tsybimage.Setdatafield(Value :SybObjectname);
begin
  fdatafield:=value;
end;

procedure tsybimage.Setdatatype(Value :SybObjectname);
begin
  fdatatype:=value;
end;

procedure tsybimage.Settablename(Value :SybObjectname);
var thisform  :tform;
    i,j       :smallint;
    asybtable :tsybtable;
begin
  thisform:=tform(owner);

  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=tablename) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.deletefield(name);
      break;
    end;
  end;

  Ftablename:=value;

  for i := 0 to thisform.ComponentCount - 1 do
  begin
    if (thisform.Components[i] is TSybTable)
      and (thisform.Components[i].name=value) then
    begin
      asybtable:=tsybtable(thisform.Components[i]);
      asybtable.addfield(name);
      break;
    end;
  end;

end;

procedure Tsybobjectproperty.GetValues(TheProc: TGetStrProc);
var i,j       :integer;
    thisform  :tform;
    teditf    :tsybimage;
    nm        :string;
    asybtable :tsybtable;

begin
  teditf:=tsybimage(getcomponent(0));
  thisform:=tform(teditf.owner);
  if getname = 'TableName' then
  begin
    for i := 0 to thisform.ComponentCount - 1 do
    begin
      with thisform.Components[i] do { as TControl) do}
      begin
        if thisform.Components[i] is TSybTable then
         theproc(thisform.Components[i].name);
      end;
    end;
  end;
  if getname = 'Datatype' then
  begin
    theproc('datetime');
    theproc('float');
    theproc('int');
    theproc('char');
    theproc('bit');
    theproc('text');
  end;
  if getname = 'DataField' then
  begin
    for i := 0 to thisform.ComponentCount - 1 do
    begin
      if (thisform.Components[i] is TSybTable)
        and (thisform.Components[i].name=teditf.tablename) then
      begin
        asybtable:=tsybtable(thisform.Components[i]);
        for j:=1 to asybtable.datafieldscount do
          theproc(asybtable.datafields[j]);
      end;
    end;

  end;

end;

function Tsybobjectproperty.getattributes:Tpropertyattributes;
begin
  Result := [paValueList,paAutoUpdate,paMultiSelect];
end;

end.
